//////////////////////////////////////////////////////////////////////////////
//
// $Id: buildstr.C,v 1.3 2001/07/21 10:27:10 assman Exp $
//
// $Log: buildstr.C,v $
// Revision 1.3  2001/07/21 10:27:10  assman
// Added semaphore interface
// Added functions to manage usec resolution time
// fixed bugfixes
// this is the first public release of the library
//
// Revision 1.2  2001/06/24 13:43:06  assman
// added full cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////
#include <buildstr>

string TOOLS::buildstr(const char *tpl, ...) {
  
  va_list args;             // define argument list variable
  va_start (args,tpl);      // init list; point to last
  //  defined argument

  if (tpl == NULL) return("");

  string ltpl = tpl;
  string p_str = "";
  char   p_char = '\0';
  int    p_int = 0;
  double  p_double = 0.0;
  unsigned int f;
  unsigned int k;

  f = ltpl.find("%");
  while (f != string::npos) {
 
    if (f+1>= ltpl.size()) return(ltpl);

    switch (ltpl[f+1]) {

    case 's': {
      p_str = (const char *)va_arg(args,char *);
      ltpl.replace(f,2,p_str);
       break;
    }
    case 'i':
    case 'd': {
      p_int = va_arg(args, int);
      ltpl.replace(f,2,TOOLS::itoa(p_int));
       break;
    }
    case 'f': {
      p_double = va_arg(args, double);
      ltpl.replace(f,2,TOOLS::ftoa(p_double));
      break;
     }
    case 'c': {
      p_char = va_arg(args, char);
      ltpl.replace(f,2,p_char);
      break;
     }

    }
 
    //
    // test for unsupported values
    //

    k = ltpl.find("%");    
    if (f == k) {
      ltpl.replace(k,1,"_");
      f = ltpl.find("%");
    }
    else f = k;
  }

 
  va_end (args);  // clean up the system stack
  return(ltpl);
}
