//////////////////////////////////////////////////////////////////////////////
//
// $Id: lock.h,v 1.2 2001/06/24 13:43:10 assman Exp $
// An interface for locks & condition locks
// Juan M. Casillas
// <assman@gsyc.inf.uc3m.es>
// 13/May/2001 (15:44)
//
//////////////////////////////////////////////////////////////////////////////
//
// 15/May/2001 (Tue 11:33) Fixed a bug in wait() that does a lock also
// $Log: lock.h,v $
// Revision 1.2  2001/06/24 13:43:10  assman
// added full cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __LOCK_H__
#define __LOCK_H__

#include <pthread.h>

class Lock {

public:
	
    Lock() { 
	pthread_mutex_init(&_lock, NULL); 
    }

    ~Lock() { 
	pthread_mutex_destroy(&_lock); 
    }

    void lock(void) { 
	pthread_mutex_lock(&_lock);
    }

    void release(void) {
	pthread_mutex_unlock(&_lock);
    }
  
protected:
  
  pthread_mutex_t  _lock;

};

class LockCond: public Lock {
 public:

  LockCond(): Lock() {
    pthread_cond_init(&_cond, NULL);
  }

  virtual ~LockCond() { 
    pthread_cond_destroy(&_cond);
  }

  void wait(void) {
    pthread_cond_wait(&_cond,&_lock);
  }

  void signal(void) {
    pthread_cond_signal(&_cond);
  }
    
 protected:

  pthread_cond_t _cond;

};

#endif
