//////////////////////////////////////////////////////////////////////////////
//
// $Id: paircontainer.h,v 1.2 2001/06/24 13:43:17 assman Exp $
// a pair (attribute / value) container
//
// $Log: paircontainer.h,v $
// Revision 1.2  2001/06/24 13:43:17  assman
// added full cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __PAIRCONTAINER_H__
#define __PAIRCONTAINER_H__

#include <map>

template <class A, class V> class pair_container {
public:
  pair_container() { init(); }
  pair_container(A attr, V value) {
    add(attr,value);
  }

  pair_container(const pair_container &p) {
    _map = p._map;
  }
    
  ~pair_container() { init(); }

  void init(void) {
    _map.erase(_map.begin(),_map.end());
  }

  void add(A attr, V value) {
    _map[attr] = value;
  }

  int size(void) {
    return(_map.size());
  }
  
  V operator[](A idx) {
    return(_map[idx]);
  }

  //
  // we can go out of bounds here
  // so please use it with size()
  // return the value
  //

  V operator[](int idx) {
    int n;
    map<A,V>::iterator it = _map.begin();
    
    for (n=0; n< idx; n++, it++);

    //
    // first is the attribute field
    // second is the value field
    //

    return((*it).second);
  }

  //
  // we can go out of bounds here
  // so please use it with size()
  // return the key (that is, the
  // attribute)
  //

  A key(int idx) {
    int n;
    map<A,V>::iterator it = _map.begin();
    
    for (n=0; n< idx; n++, it++);

    //
    // first is the attribute field
    // second is the value field
    //

    return((*it).first);
  }


  //
  // test if the Key (Attribute) exists in the map
  //

  bool exists(A value) {
    return(_map.find(value) ==  _map.end() ? false : true);
  }

  private:
    map<A,V> _map;
};

#endif
