//////////////////////////////////////////////////////////////////////////////
//
// $Id: pgadapter.h,v 1.2 2001/06/24 13:43:20 assman Exp $
//
// A simple postgres db adapter
//
// $Log: pgadapter.h,v $
// Revision 1.2  2001/06/24 13:43:20  assman
// added full cvs tags
//
// Revision 1.1  2001/06/24 13:23:35  assman
// added new rules to compile all from a single makefile
// added support for new log types (syslog, file, dummy logger)
// added support for a generic network threaded server
// added support for an adapter to the postgres database
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __PGADAPTER_H__
#define __PGADAPTER_H__

#include <libpq++.h>
#include <buildstr>
#include <numconv>


class PgAdapter: public PgDatabase {
public:

  PgAdapter(string conninfo): PgDatabase(conninfo.c_str()) {
    _conninfo = conninfo;
  }

  PgAdapter(string host,
	    string dbname,
	    string user,
	    string password,
	    int port=5432) {
    _conninfo = TOOLS::buildstr("host=%s port=%d dbname=%s "
				"user=%s password=%s",
				host.c_str(),port,dbname.c_str(),
				user.c_str(),password.c_str());
    Connect(_conninfo.c_str());
  }
    
  virtual ~PgAdapter() { }


protected:
  string _conninfo;

};

#endif
