//////////////////////////////////////////////////////////////////////////////
//
// $Id: regexpressions.C,v 1.3 2001/07/21 10:27:15 assman Exp $
//
// $Log: regexpressions.C,v $
// Revision 1.3  2001/07/21 10:27:15  assman
// Added semaphore interface
// Added functions to manage usec resolution time
// fixed bugfixes
// this is the first public release of the library
//
// Revision 1.2  2001/06/24 13:43:23  assman
// added full cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#include <regexpressions>

const int REGEXP::ERROR::success = 0;
const int REGEXP::ERROR::badcompile = 1;
const int REGEXP::ERROR::badmatch = 2;
	
const char *REGEXP::ERROR::errlist[] = {
  "Success",
  "Bad regexp compile",
  "Bad regexp match"
};	


void Regexpression::clear(void) {
  if (_compiled) {
    regfree(_reg_buff);
    _compiled = false;
  }
}

int Regexpression::compile(string str) {
  _compiled = true;
  if (regcomp(_reg_buff,str.c_str(),_flags) != 0) {
    _errnum = REGEXP::ERROR::badcompile;
    return(0);
  }
  return(1);
}

bool Regexpression::test(string str) {
  int ret;
  ret = regexec(_reg_buff,str.c_str(),0,_matches,_mflags);
  switch (ret) {
  case REG_NOMATCH:  return(false);
  case 0:            return(true);
  default:           _errnum= REGEXP::ERROR::badmatch;
  }
  return(false);
}

bool Regexpression::regmatch(string reg, string str) {
  bool ret;
  if (!compile(reg)) return(false);
  ret = test(str);
  clear();
  return(ret);
}
