//////////////////////////////////////////////////////////////////////////////
//
// $Id: regexpressions.h,v 1.4 2001/07/21 10:27:15 assman Exp $
// A basic regular expression Matching
// Juan M. Casillas
// assman@gsyc.inf.uc3m.es
// 19/may/2001 (Sat 23:00)
//
// $Log: regexpressions.h,v $
// Revision 1.4  2001/07/21 10:27:15  assman
// Added semaphore interface
// Added functions to manage usec resolution time
// fixed bugfixes
// this is the first public release of the library
//
// Revision 1.3  2001/06/24 13:43:23  assman
// added full cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __REGEXPRESSIONS_H__
#define __REGEXPRESSIONS_H__

#include <string>
#include <regex.h>
#include <errormgmt>

namespace REGEXP {
    namespace ERROR {
	 extern const int success;
	 extern const int badcompile;
	 extern const int badmatch;
	 extern const char *errlist[];
    }
}


class RegexpError: public GenericError {
public:
  RegexpError()  { clearerr(); }
  int errnum(void) { return(_errnum); }
  string strerr(void) { 
      string ret = REGEXP::ERROR::errlist[_errnum];
    return(ret); 
  }
  void clearerr(void) {
    _errnum = REGEXP::ERROR::success;
  }

protected:
  int _errnum;
};


class Regexpression: public RegexpError {
public:

  Regexpression(int flags = REG_EXTENDED|REG_NOSUB, int mflags=0):
    RegexpError(),
    _flags(_flags),
    _mflags(0),
    _compiled(false) { }
  
  virtual ~Regexpression() {
    clear();
  }
  
  void clear(void);
  int compile(string str);
  bool test(string str);
  bool regmatch(string reg, string str);


protected:

    int _flags;
    int _mflags;
    int _compiled;
    regex_t _reg_buff[1];
    regmatch_t _matches[1];
};

#endif
