//////////////////////////////////////////////////////////////////////////////
//
// $Id: sem.C,v 1.1 2001/07/21 10:27:17 assman Exp $
// An interface for semaphores
// Juan M. Casillas
// <assman@gsyc.inf.uc3m.es>
// 13/May/2001 (15:44)
//
//////////////////////////////////////////////////////////////////////////////
//
// $Log: sem.C,v $
// Revision 1.1  2001/07/21 10:27:17  assman
// Added semaphore interface
// Added functions to manage usec resolution time
// fixed bugfixes
// this is the first public release of the library
//
//
//////////////////////////////////////////////////////////////////////////////

#include <sem>


Semaphore::Semaphore(unsigned int value=0) {
  int ret;
  ret = sem_init(&_sem, 0, value);
  if (ret < 0) {
    cout << "Can't create semaphore" << endl;
    exit(-1);
  }
}

Semaphore::~Semaphore() {
  sem_destroy(&_sem);
}

int Semaphore::value(void) {
  int val;
  sem_getvalue(&_sem,&val);
  return(val);
}

void Semaphore::wait(void) {
  sem_wait(&_sem);
}

void Semaphore::post(void) {
  sem_post(&_sem);
}

