//////////////////////////////////////////////////////////////////////////////
//
// $Id: serialize.h,v 1.3 2001/07/21 10:27:18 assman Exp $
//
// $Log: serialize.h,v $
// Revision 1.3  2001/07/21 10:27:18  assman
// Added semaphore interface
// Added functions to manage usec resolution time
// fixed bugfixes
// this is the first public release of the library
//
// Revision 1.2  2001/06/24 13:43:24  assman
// added full cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __SERIALIZE_H__
#define __SERIALIZE_H__

#include <string>
#include <errormgmt>

namespace SERIALIZE {
  namespace ERROR {
    extern const int success;
    extern const int badparse;
    
    extern const char *errlist[];
  }
}

class Serialize_Base {
public:

  virtual string serialize(void) = 0;
  virtual void deserialize(string data) = 0;

};

class SerializeError: public GenericError {
public:
  SerializeError()  { clearerr(); }
  int errnum(void) { return(_errnum); }
  string strerr(void) {
      string ret = SERIALIZE::ERROR::errlist[_errnum];
    return(ret); 
  }
  void clearerr(void) {
    _errnum = SERIALIZE::ERROR::success;
  }

protected:
  int _errnum;
};


//
// the real Serialize clase
// for now, only use Serialize_Base
//

class Serialize: public Serialize_Base { };


#endif
