//////////////////////////////////////////////////////////////////////////////
//
// $Id: signals.C,v 1.3 2001/07/21 10:27:20 assman Exp $
//
// $Log: signals.C,v $
// Revision 1.3  2001/07/21 10:27:20  assman
// Added semaphore interface
// Added functions to manage usec resolution time
// fixed bugfixes
// this is the first public release of the library
//
// Revision 1.2  2001/06/24 13:43:26  assman
// added full cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#include <signal.h>
#include <unistd.h>
#include <cstdio>
#include <cstdlib>

#include <signals>
//
// register a signal handler with all the common signals that 
// stops a program
//

void TOOLS::setquithandler(void quithdl(int)) {
  struct sigaction sig;

  sig.sa_handler = quithdl;
  sig.sa_flags = 0;
  sigemptyset(&sig.sa_mask);
  sigaction(SIGINT,&sig,NULL);
  sigaction(SIGQUIT,&sig,NULL);
  sigaction(SIGABRT,&sig,NULL);
  sigaction(SIGTERM,&sig,NULL);
}

void TOOLS::sethuphandler(void huphdl(int)) {
  struct sigaction sig;

  sig.sa_handler = huphdl;
  sig.sa_flags = SA_RESTART;
  sigemptyset(&sig.sa_mask);
  sigaction(SIGHUP,&sig,NULL);
}

//
// used to ignore SIG_PIPE ... some funny clients
// send this signal when they don't have more data
// to send to the server
//

void TOOLS::ignore_sigpipe(void) {
  struct sigaction sig;

  sig.sa_handler = SIG_IGN;
  sig.sa_flags = 0;
  sigemptyset(&sig.sa_mask);
  sigaction(SIGPIPE,&sig,NULL);
}

//
// disconnect process from terminal
//

void TOOLS::disconnect_from_terminal(void) {
  
  // be sure we don't get nasty signals //
  // signal(SIGINT, SIG_IGN);
  // signal(SIGQUIT, SIG_IGN);
  setsid();
}
