//////////////////////////////////////////////////////////////////////////////
//
// $Id: example.C,v 1.3 2001/06/24 13:30:44 assman Exp $
// 29/apr/2001 (sun, 14:43)
//
// A templatized tree class
// this is a simple implementation for a multi-child tree, that can store
// any type of data.
//
// $Log: example.C,v $
// Revision 1.3  2001/06/24 13:30:44  assman
// added more cvs tags
//
// Revision 1.2  2001/06/24 13:29:34  assman
// added cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>

template <class T> class tree {
public:

  tree() { init(); }

  tree(T data) { add(data); }

  tree(const tree &t) {

    _active = t._active;
    _data   = t._data;
    _childs = t._childs;

  }

  ~tree() {
    init();
  }

  void init(void) {
    _active = false;
    if (_childs.size() > 0) {
      _childs.erase(_childs.begin(),_childs.end());
    }
  }

  bool active(void) {
    return(_active);
  }

  void print(unsigned int indent=0) {
    unsigned int n=0;
    string s_ind = "";
    for (n=0; n< indent; n++) s_ind += " ";

    if (_active) {
      cout << s_ind << "node: " << _data << endl;
      for (n=0; n < _childs.size(); n++) {
	_childs[n].print(indent+5);
      }
    }
  }

  int size(void) {                               
    return _childs.size(); 
  }  

  void add(T data) {
    _data = data;
    _active = true;
  }
  
  bool addchild(tree data) {
    if (!_active) return(false);
    _childs.push_back(data);
    return(true);
  }
  
  // 
  // store a copy of the element
  // instead the element itself
  // note that for destruction pourpouses, the element
  // must have its own destructors defined
  //

  bool addchild(T data) {
    tree *t;
    if (!_active) return(false);
    t = new tree(data);
    addchild(*t);
    delete t;
    return(true);
  }
  
protected:
  vector<tree> _childs;   // the childs
  T            _data;     // the data 
  bool         _active;   // this node has elements
};

int main(int argc, char *argv[]) {

  tree<string> _tree("node1");
  tree<string> _tree2("node2");

  _tree2.addchild("child-1");
  _tree2.addchild("child-2");
  _tree.addchild(_tree2);
  _tree.print();


return(0);
}
