//////////////////////////////////////////////////////////////////////////////
//
// $Id: tree.h,v 1.3 2001/06/24 13:30:42 assman Exp $
// a templatized tree class
// 
// $Log: tree.h,v $
// Revision 1.3  2001/06/24 13:30:42  assman
// added more cvs tags
//
// Revision 1.2  2001/06/24 13:29:32  assman
// added cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __TREE_H__
#define __TREE_H__

#include <vector>

template <class T> class tree {
public:

  tree() { init(); }

  tree(const T &data) { add(data); }

  tree(const tree &t) {

    _active = t._active;
    _data   = t._data;
    _childs = t._childs;

  }

  virtual ~tree() {
    init();
  }

  void init(void) {
    _active = false;
    if (_childs.size() > 0) {
      _childs.erase(_childs.begin(),_childs.end());
    }
  }

  bool active(void) {
    return(_active);
  }

  tree<T> search(T data) {
      unsigned int n;
      tree<T> tmp_a;
      if (_active) {
	  if (data == _data) {
	      tree<T> tmp(*this);
	      return(tmp);
	  }
	  else {
	      for (n=0; n< _childs.size(); n++) {
		  tmp_a = _childs[n].search(data);
		  if (tmp_a.active()) return(tmp_a);
	      }
	  }
      }
      return(tmp_a);
  }

  void print(unsigned int indent=0) {
      unsigned int n=0;
      string s_ind = "";
      for (n=0; n< indent; n++) s_ind += " ";
      
      if (_active) {
	  cout << s_ind << "node: " << _data;
	  for (n=0; n < _childs.size(); n++) {
	      _childs[n].print(indent+5);
	  }
      }
  }
  
  int size(void) {                               
    return _childs.size(); 
  }  

  void add(const T &data) {
    _data = data;
    _active = true;
  }
  
  bool addchild(const tree &data) {
    if (!_active) return(false);
    _childs.push_back(data);
    return(true);
  }

  T data(void) {
    return(_data);
  }

  
  
  // 
  // store a copy of the element
  // instead the element itself
  // note that for destruction pourpouses, the element
  // must have its own destructors defined
  //

  bool addchild(const T &data) {
    tree *t;
    if (!_active) return(false);
    t = new tree(data);
    addchild(*t);
    delete t;
    return(true);
  }

  T operator[](unsigned int idx) {
      return(_childs[idx]._data);
  }

 
protected:
  vector<tree> _childs;   // the childs
  T            _data;     // the data 
  bool         _active;   // this node has elements
};

#endif
